INCLUDE \masm32\include\masm32rt.inc
.586
INCLUDE \masm32\macros\timers.asm

.data
buf BYTE 30 DUP(0)
val1 DWORD -1		;maximum unsigned value

.code
;  

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
ALIGN 16
udw2str2 proc dwNumber:DWORD, pszString:DWORD

    mov eax, [esp+4]

    cmp eax, 9
    ja @F
    mov edx, 1
    jmp nxt
  @@:
    cmp eax, 99
    ja @F
    mov edx, 2
    jmp nxt
  @@:
    cmp eax, 999
    ja @F
    mov edx, 3
    jmp nxt
  @@:
    cmp eax, 9999
    ja @F
    mov edx, 4
    jmp nxt
  @@:
    cmp eax, 99999
    ja @F
    mov edx, 5
    jmp nxt
  @@:
    cmp eax, 999999
    ja @F
    mov edx, 6
    jmp nxt
  @@:
    cmp eax, 9999999
    ja @F
    mov edx, 7
    jmp nxt
  @@:
    cmp eax, 99999999
    ja @F
    mov edx, 8
    jmp nxt
  @@:
    cmp eax, 999999999
    ja @F
    mov edx, 9
    jmp nxt
  @@:
    mov edx, 10

  nxt:
    mov eax, [esp+4]            ; src
    mov ecx, [esp+8]            ; lpdest             ; buffer address

    push ebx
    push esi
    push edi

    mov esi, 0CCCCCCCDh         ; "magic number" multiplier for division by 10
    mov ebx, 10
    add ecx, edx                ; add required buffer length to start address
    mov BYTE PTR [ecx], 0       ; write the terminator
    sub ecx, 1                  ; decrement down to first write position

  @@:
    mul esi                     ; multiply by magic number
    shrd eax, edx, 3            ; binary fractional "remainder" back in EAX
    shr edx, 3                  ; EDX = quotient
    add eax, 1                  ; precaution against occasional "underflow"
    mov edi, edx                ; save current quotient for next division
    mul ebx                     ; x10 gets "decimal" remainder into EDX
    add dl, 30h                 ; convert remainder to ascii
    mov [ecx], dl               ; insert it into buffer
    sub ecx, 1                  ; decrement buffer location
    mov eax, edi                ; retrieve current quotient
    test eax, eax               ; test if done
    jz @F                       ; continue if not done

    mul esi                     ; multiply by magic number
    shrd eax, edx, 3            ; binary fractional "remainder" back in EAX
    shr edx, 3                  ; EDX = quotient
    add eax, 1                  ; precaution against occasional "underflow"
    mov edi, edx                ; save current quotient for next division
    mul ebx                     ; x10 gets "decimal" remainder into EDX
    add dl, 30h                 ; convert remainder to ascii
    mov [ecx], dl               ; insert it into buffer
    sub ecx, 1                  ; decrement buffer location
    mov eax, edi                ; retrieve current quotient
    test eax, eax               ; test if done
    jnz @B                      ; continue if not done

  @@:
    pop edi
    pop esi
    pop ebx

    mov eax, [esp+8]

    ret 8

udw2str2 endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

;  
ALIGN 16
;u32toa by brethren
u32toa PROC, value:DWORD, szbuf:DWORD
	pushad
	mov eax, value
	mov ebx, 0CCCCCCCDh
	mov esi, szbuf
	mov edi, esi
@@:
	mov ecx, eax
	mul ebx
	shr edx, 3
	mov eax, edx
	lea edx, [edx+edx*4]
	add edx, edx
	sub ecx, edx
	add cl, '0'
	mov [esi], cl
	add esi, 1
	test eax, eax
	ja @B

	mov BYTE PTR [esi], NULL
	sub esi, 1
@@:
	mov al, [edi]
	mov bl, [esi]
	mov [edi], bl
	mov [esi], al
	add edi, 1
	sub esi, 1
	cmp edi, esi
	jb @B

	popad
	ret
u32toa ENDP

;  

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

ALIGN 16
; u32toa by brethren
utoa2 PROC, value:DWORD, szbuf:DWORD

    push ebx
    push esi
    push edi

    mov eax, [esp+4][12]       ; value
    mov esi, [esp+8][12]       ; szbuf

    cmp eax, 9
    ja lb1
    add esi, 1
    jmp nxt
  lb1:
    cmp eax, 99
    ja lb2
    add esi, 2
    jmp nxt
  lb2:
    cmp eax, 999
    ja lb3
    add esi, 3
    jmp nxt
  lb3:
    cmp eax, 9999
    ja lb4
    add esi, 4
    jmp nxt
  lb4:
    cmp eax, 99999
    ja lb5
    add esi, 5
    jmp nxt
  lb5:
    cmp eax, 999999
    ja lb6
    add esi, 6
    jmp nxt
  lb6:
    cmp eax, 9999999
    ja lb7
    add esi, 7
    jmp nxt
  lb7:
    cmp eax, 99999999
    ja lb8
    add esi, 8
    jmp nxt
  lb8:
    cmp eax, 999999999
    ja lb9
    add esi, 9
    jmp nxt
  lb9:
    add esi, 10

  nxt:

    mov ebx, 0CCCCCCCDh
    mov BYTE PTR [esi], 0
    sub esi, 1

  stlp:
    mov ecx, eax
    mul ebx
    shr edx, 3
    mov eax, edx
    lea edx, [edx+edx*4]
    lea edx, [edx+edx]
    sub ecx, edx
    add cl, '0'
    mov [esi], cl
    sub esi, 1
    test eax, eax
    jbe lpqt

    mov ecx, eax
    mul ebx
    shr edx, 3
    mov eax, edx
    lea edx, [edx+edx*4]
    lea edx, [edx+edx]
    sub ecx, edx
    add cl, '0'
    mov [esi], cl
    sub esi, 1
    test eax, eax
    ja stlp

  lpqt:
    pop edi
    pop esi
    pop ebx

    ret 8

utoa2 ENDP

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

;  
;----------------------------------------------------------
main PROC
	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE udw2str2, val1, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for udw2str2",13,10)

	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE u32toa, val1, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for u32toa",13,10)

	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE utoa2, val1, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for utoa2",13,10)

	inkey

	exit
main ENDP
END main
